"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.killAll = exports.addProcess = exports.wasKillAll = void 0;
const run_state_1 = require("./run-state");
const log_1 = require("./log");
const contracts_1 = require("./contracts");
const kill_process_1 = require("@flemist/kill-process");
let _wasKillAll;
function wasKillAll() {
    return _wasKillAll;
}
exports.wasKillAll = wasKillAll;
const processList = [];
function addProcess(proc) {
    processList.push(proc);
}
exports.addProcess = addProcess;
process.on('SIGTERM', () => {
    console.log('SIGTERM');
    killAll({ isFailure: true });
});
process.on('SIGHUP', () => {
    console.log('SIGHUP');
    killAll({ isFailure: true });
});
process.on('SIGINT', () => {
    console.log('SIGINT');
    killAll({ isFailure: true });
});
process.on('SIGBREAK', () => {
    console.log('SIGBREAK');
    killAll({ isFailure: true });
});
process.on('beforeExit', () => {
    // console.log('beforeExit')
    killAll({ isFailure: false });
});
process.on('exit', () => {
    console.log('exit');
    killAll({ isFailure: false });
});
// process.on('disconnect', killAll)
process.on('uncaughtException', err => {
    log_1.printError('uncaughtException', err);
    killAll({ isFailure: true });
});
function killAll({ isFailure, }) {
    if (_wasKillAll) {
        return;
    }
    _wasKillAll = true;
    console.log('Terminating...');
    // const procs = processList.filter(o => o.pid && !o.killed && o.pid !== process.pid)
    // const pids = procs.map(o => o.pid)
    log_1.printRunStates();
    kill_process_1.finalizeProcesses({
        description: 'run-script killAll',
        firstDelay: 100,
        softKillFirst: true,
        softKillDelay: 1000,
        outside: true,
        state: {
            pid: process.pid,
        },
        createFilter(state, _require) {
            const { createProcessTreeFilter } = _require('@flemist/find-process');
            return createProcessTreeFilter({
                parentsPids: [state.pid],
            });
        },
    });
    if (run_state_1.getRunStates().some(o => o.status === contracts_1.RunStatus.ERROR)) {
        isFailure = true;
    }
    run_state_1.clearRunStates();
    if (isFailure) {
        // eslint-disable-next-line no-process-exit
        process.exit(1);
    }
}
exports.killAll = killAll;
